module http;

private import
	socket, std.string;

/*連続した数字を読むユーティリティ*/
int scan_int(inout char[] s)
{
	int result = 0;
	while(s.length > 0 && s[0] >= '0' && s[0] <= '9'){
		result = result * 10 + (s[0] - '0');
		s = s[1..s.length];
	}
	return result;
}

/*URIを分解*/
void disassemble_uri(char[] uri, out char[] server_name, out ushort port, out char[] request)
{
	if(uri[0..7] == `http://`){
		uri = uri[7..uri.length];
	}
	int i = find(uri, '/');
	if(i >= 0){
		server_name = uri[0..i];
		request = uri[i..uri.length];
	}else{
		server_name = uri;
		request = `/`;
	}
	port = 80;
	int p = find(server_name, ':');
	if(p >= 0){
		char[] port_s = server_name[p + 1..server_name.length];
		port = scan_int(port_s);
		server_name = server_name[0..p];
	}
}

class HTTP_Client : Object
{
	Client_Socket socket;
	
	this()
	{
		socket = null;
	}
	
	char[] get(char[] uri)
	{
		release_socket();
		IP_Address ip;
		ushort port;
		char[] server_name;
		char[] request;
		disassemble_uri(uri, server_name, port, request);
		//printf("%.*s\n", server_name);
		ip = to_ip(server_name);
		socket = new Client_Socket(ip, port);
		socket.send(cast(ubyte[])(
			`GET ` ~ request ~ ` HTTP/1.1`\n ~
			`User-Agent: poo`\n ~
			`Host: ` ~ server_name ~ \n ~
			`Connection: close`\n\n
		));
		//return cast(char[])(socket.receive(int.max));
		return cast(char[])(socket.receive_all);
	}
	
	void release_socket()
	{
		if(socket !== null){
			socket.close();
			socket = null;
		}
	}
}

