﻿//poo main

version = GUI;
version = dyaregexp;

private import
	win32.windows, std.stream, std.utf, std.file, std.gc, dyayaml,
	socket, http, proxy;

version(dyaregexp){
	private import dyaregexp;
}else{
	private import std.regexp;
}

version(GUI){
	alias TCHAR[] Version_Text;
}else{
	alias char[] Version_Text;
}

const Version_Text version_text = `Proxomitronomitron version alpha-01`\0;

struct Filter
{
	char[] uri;
	char[] search;
	char[] replace;
	RegExp compiled_uri;
	RegExp compiled_search;
	/*bit*/ uint valid; 
	//うまくアライメントされない！？→4の倍数じゃないところに[1]以降が配置されGCで解放されてる！？
}

Filter[] filter;
Object filter_using;

void io_setting(Yaml_IO yaml)
{
	int index;

	yaml.io(delegate void(){
		yaml.io("filter", dynamic_array!(Filter[]).wrap(&filter), delegate void(int i){
			index = i; //コンパイラのバグ対策
			yaml.io(delegate void(){
				//MessageBoxA(null, toStringz(toString(index)), "", 0);
				yaml.io("uri", filter[index].uri);
				yaml.io("search", filter[index].search);
				yaml.io("replace", filter[index].replace);
			});
		});
	});
}

version(dyaregexp){
	const Options u_options = Options.case_insensitive;
	const Options r_options = Options.case_insensitive | Options.multi_line;
	const Encoding encoding = Encoding.ascii;
}else{
	const char[] u_options = "ig";
	const char[] r_options = "img";
}

void load_setting()
{
	char[] source = cast(char[])read(`setting.yaml`);
	auto Yaml_Reader reader = new Yaml_Reader(`poo`, source);
	io_setting(reader);
	for(int i = 0; i < filter.length; ++i){
		try{
			version(dyaregexp){
				filter[i].compiled_uri = new RegExp(filter[i].uri, encoding, u_options);
				filter[i].compiled_search = new RegExp(filter[i].search, encoding, r_options);
			}else{
				filter[i].compiled_uri = new RegExp(`^` ~ filter[i].uri ~ `$`, u_options);
				filter[i].compiled_search = new RegExp(filter[i].search, r_options);
			}
			filter[i].valid = true;
		}catch(RegExpError e){
			filter[i].valid = false;
			char[] msg = toString(i) ~ "番目の正規表現が変です\0";
			MessageBoxA(null, msg, e.classinfo.name, MB_ICONERROR);
		}
	}
}

char[] html_filter(char[] uri, char[] s)
{
	char[] t = s;
	synchronized(filter_using){
		for(int i = 0; i < filter.length; ++i){
			if(filter[i].valid){
				bit b = false;
				try{
					version(dyaregexp){
						b = filter[i].compiled_uri.equals(uri);
					}else{
						b = filter[i].compiled_uri.search(uri) >= 0;
					}
				}catch(Exception e){
					stderr.printf(`error URI %.*s (%.*s) %d "%.*s"`\r\n, e.toString(), e.classinfo.name, i, uri);
					version(dyaregexp){
						//なぜかVMTが破壊されている時があるので作り直す←GC？
						filter[i].compiled_uri = new RegExp(filter[i].uri, encoding, u_options);
						//それで例外が起きるなら仕方がない
						b = filter[i].compiled_uri.equals(uri);
						//↑でまた例外が起きたらここは通過しない
						stderr.printf(`reconstructed.`\r\n);
					}else{
						throw e;
					}
				}
				if(b){
					stdout.printf(`** Hit %d rule. **`\n, i);
					try{
						t = filter[i].compiled_search.replace(t, filter[i].replace);
					}catch(Exception e){
						stderr.printf(`error HTML %.*s (%.*s) %d "%.*s"`\r\n, e.toString(), e.classinfo.name, i, uri);
						version(dyaregexp){
							//同上、作り直す
							filter[i].compiled_search = new RegExp(filter[i].search, encoding, r_options);
							//それで例外が起きるなら仕方がない
							t = filter[i].compiled_search.replace(t, filter[i].replace);
							//↑でまた例外が起きたらここは通過しない
							stderr.printf(`reconstructed.`\r\n);
						}else{
							throw e;
						}
					}
				}
			}
		}
	}
	return t;
}

version(GUI){

	enum { WM_APP_ICON = WM_USER + 1000 }
	
	NOTIFYICONDATA icon = {
		cbSize: NOTIFYICONDATA.sizeof,
		uID: 100,
		uFlags: NIF_ICON | NIF_MESSAGE | NIF_TIP,
		uCallbackMessage: WM_APP_ICON,
		szTip: "Proxomitronomitron"
		};
	
	WNDPROC original_proc;
	
	extern(Windows) LRESULT WindowProc(HWND wnd, uint msg, WPARAM w, LPARAM l)
	{
		switch(msg){
		case WM_APP_ICON:
			if(w == 100){
				if(l == WM_RBUTTONUP){
					BOOL v = IsWindowVisible(wnd);
					if(!v){
						ShowWindow(wnd, SW_MINIMIZE);
					}
					SetForegroundWindow(wnd);
					HMENU menu = CreatePopupMenu;
					AppendMenu(menu, MF_STRING, 200, `&Show`);
					AppendMenu(menu, MF_STRING, 201, `&Hide`);
					AppendMenu(menu, MF_SEPARATOR, 0, null);
					AppendMenu(menu, MF_STRING, 300, `&Reload`);
					AppendMenu(menu, MF_SEPARATOR, 0, null);
					AppendMenu(menu, MF_STRING, 400, `&Exit`);
					POINT p;
					GetCursorPos(&p);
					TrackPopupMenu(menu, TPM_RIGHTBUTTON, p.x, p.y, 0, wnd, null);
					DestroyMenu(menu);
					if(!v){
						ShowWindow(wnd, SW_HIDE);
					}
				}
			}
			return 0;
		case WM_COMMAND:
			switch(w){
			case 200:
				ShowWindow(wnd, SW_RESTORE);
				ShowWindow(wnd, SW_SHOW);
				return 0;
			case 201:
				ShowWindow(wnd, SW_HIDE);
				return 0;
			case 300:
				load_setting();
				return 0;
			case 400:
				PostMessage(wnd, WM_CLOSE, 0, 0);
				return 0;
			default:
				;
			}
			break;
		case WM_SYSCOMMAND:
			if(w == SC_CLOSE){
				ShowWindow(wnd, SW_HIDE);
				return 0;
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
		default:
			;
		}
		return CallWindowProc(original_proc, wnd, msg, w, l);
	}
	
	class Log_Stream : File
	{
		char[] buffer;
		override void writeString(char[] s)
		{
			synchronized(this){
				buffer ~= s;
				for(;;){
					int i = find(buffer, '\n');
					if(i < 0) break;
					TCHAR* s;
					try{
						int j = i;
						if(i > 0 && buffer[i - 1] == '\r'){
							--j;
						}
						s = toUTF16z(buffer[0..j]);
					}catch{
						s = `(BIN)`\0;
					}
					SendMessage(icon.hWnd, LB_ADDSTRING, 0, cast(LPARAM)s);
					//buffer = buffer[i + 1..buffer.length].dup;
					buffer = buffer[i + 1..buffer.length];
					if(SendMessage(icon.hWnd, LB_GETCOUNT, 0, 0) > 1024){
						SendMessage(icon.hWnd, LB_DELETESTRING, 0, 0);
					}
				}
			}
		} /*writeString*/
	} /*Log_Stream*/
	
	extern (C) void gc_init();
	extern (C) void gc_term();
	extern (C) void _minit();
	extern (C) void _moduleCtor();
	extern (C) void _moduleUnitTests();
	
	extern (Windows) int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR CmdLine, int CmdShow)
	{
		gc_init();
		_minit();
		try{
			_moduleCtor();
			_moduleUnitTests();
	
			const TCHAR* window_class_name = `poo_window`\0;
			if(FindWindow(window_class_name, null) != null){
				throw new Exception(`二重起動になります`);
			}
	
			filter_using = new Object();
			load_setting();
	
			WNDCLASSEX wc;
			wc.cbSize = wc.sizeof;
			GetClassInfoEx(null, "LISTBOX", &wc);
			original_proc = wc.lpfnWndProc;
			wc.lpszClassName = window_class_name;
			wc.lpfnWndProc = &WindowProc;
			wc.hInstance = hInstance;
			wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(1));
			ATOM r = RegisterClassEx(&wc);
			assert(r);
	
			icon.hIcon = wc.hIcon;
			icon.hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, 
				window_class_name, version_text,
				WS_OVERLAPPEDWINDOW | WS_VSCROLL | WS_HSCROLL, 
				CW_USEDEFAULT, CW_USEDEFAULT, 400, 300, 
				NULL, NULL, hInstance, NULL);
	
			assert(icon.hWnd);
	
			debug{ ShowWindow(icon.hWnd, CmdShow); }
			Shell_NotifyIcon(NIM_ADD, &icon);
			
			stdout = new Log_Stream();
	
			try{
				stderr = new File("error.log", FileMode.In | FileMode.Out);
				stderr.seek(0, SeekPos.End);
			}catch(OpenError){
				stderr = new File();
				stderr.create("error.log");
				stderr.writeString(`﻿`);
			}
	
			std.gc.fullCollect();
	
			Proxy_Thread thread = new Proxy_Thread();
			thread.html_filter = &html_filter;
			thread.start();
	
			MSG msg;
			while(GetMessage(&msg, NULL, 0, 0))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}

			thread.terminating = true;
			Client_Socket cs = new Client_Socket(to_ip("localhost"), 8080);
			thread.wait();
			cs.close();

			Shell_NotifyIcon(NIM_DELETE, &icon);
	
		}catch(Object e){
			MessageBoxW(null, toUTF16z(e.toString()), toUTF16z(e.classinfo.name), 0);
		}
		gc_term();
	
		return 0;
	}

}else{
	
	version(Win32){
		void sleep(uint sec)
		{
			Sleep(sec * 1000);
		}
	}else{
	    extern (C) uint sleep(uint sec);
	}
	
	int main() 
	{
		stdout.writeLine(version_text);
		load_setting();
		Proxy_Thread thread = new Proxy_Thread();
		thread.html_filter = &html_filter;
		thread.start();
		//Ctrl+C待ち
		for(;;){
			sleep(int.max / 10000);
		}
		return 0;
	}

}
